<!doctype html>
<html class="no-js">
<head>



<meta charset="utf-8">
<title>Learn Python the Hard Way</title>

<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="description" content="">
<meta name="viewport" content="width=device-width,initial-scale=1">

<link href='https://fonts.googleapis.com/css?family=Source+Code+Pro|Source+Sans+Pro:200,400,700,200italic,400italic,700italic' rel='stylesheet' type='text/css'>
<link href="../css/style.min.css" rel="stylesheet">
<!-- http://www.socicon.com -->
<link href="../css/icons.css" rel="stylesheet">


</head>

<body class="baseline-grid-off book-site" id="top">




<header class="header" role="banner">
    <nav class="navbar navbar-full nav-brand-family">
        <div class="row middle-xs">
            <ul class="brand-links show-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org" class="waves-effect">Learn:</a></li>

                <li><a href="https://learncodethehardway.org/python/" class="waves-effect active">Python</a></li>

                <li><a href="https://learncodethehardway.org/ruby/" class="waves-effect">Ruby</a></li>

                <li><a href="https://learncodethehardway.org/more-python/" class="waves-effect">More Python</a></li>

                <li><a href="https://learncodethehardway.org/c/" class="waves-effect">C</a></li>

                <li><a href="https://learncodethehardway.org/sql/" class="waves-effect">SQL</a></li>

                <li><a href="https://learncodethehardway.org/javascript/" class="waves-effect">Javascript</a></li>

                <li><a href="https://learncodethehardway.org/unix/" class="waves-effect">Unix</a></li>

                <li><a href="https://learncodethehardway.org/regex/" class="waves-effect">RegEx</a></li>

                <li><a href="https://www.learndesignthehardway.com/" class="waves-effect">Design</a></li>

            </ul>
            <ul class="brand-links hide-md col-xs-3 col-sm-10 bare">
                <li><a href="https://learncodethehardway.org/" class="waves-effect">LCTHW</a></li>
            </ul>

            <ul class="site-meta col-xs-9 col-sm-2 end-xs bare">
                <li><a href="https://shop.learncodethehardway.org/access/reactivate/" class="waves-effect"><i class="icon icon-user"></i> Login</a></li>
            </ul>

        </div>
    </nav>

    <nav class="navbar navbar-full nav-main" role="navigation">
        <div class="row between-xs center-xs middle-xs bare">
            <div class="col-xs-4 start-xs bare">
                <a href="ex41.html#" class="no-underline nav-trigger waves-effect" id="toc"><div class="transformer hamburcloser">
                        <div class="bar bar-t"></div>
                        <div class="bar bar-m-a"></div>
                        <div class="bar bar-m-b"></div>
                        <div class="bar bar-b"></div>
                </div><span class="nav-trigger_text show-sm-inline">Contents</span></a>
            </div>
            <div class="col-xs-4"><strong>&nbsp;</strong></div>
            <div class="col-xs-4 end-xs bare">
                <a href="https://helpthw.zendesk.com/hc/en-us" class="no-underline nav-trigger waves-effect" id="help"><div class="transformer questioncloser">
                        <div class="icon-question-mark"></div>
                </div><span class="nav-trigger_text show-sm-inline">Help</span></a>
            </div>
        </div>
    </nav>

</header>




<div class="wrapper">
    <div class="masthead python-background" style="background-image: url('/images/pattern-python.svg')">
        <img src="../images/logo-python.svg" alt="Learn Python The Hard Way" class="logo">
    </div>

    <aside class="sidebar sidebar-left" role="complementary">
        <nav class="side-nav-container">
            <ol class="table-of-contents">
                <h3>Table of Contents</h3>
                <li><a href="preface.html">Preface</a></li>
                <li><a href="intro.html">The Hard Way Is Easier</a></li>
                <li><a href="ex0.html">Ex0: The Setup</a></li>
                <li><a href="ex1.html">Ex1: A Good First Program</a></li>
                <li><a href="ex2.html">Ex2: Comments And Pound Characters</a></li>
                <li><a href="ex3.html">Ex3: Numbers And Math</a></li>
                <li><a href="ex4.html">Ex4: Variables And Names</a></li>
                <li><a href="ex5.html">Ex5: More Variables And Printing</a></li>
                <li><a href="ex6.html">Ex6: Strings And Text</a></li>
                <li><a href="ex7.html">Ex7: More Printing</a></li>
                <li><a href="ex8.html">Ex8: Printing, Printing</a></li>
                <li><a href="ex9.html">Ex9: Printing, Printing, Printing</a></li>
                <li><a href="ex10.html">Ex10: What Was That?</a></li>
                <li><a href="ex11.html">Ex11: Asking Questions</a></li>
                <li><a href="ex12.html">Ex12: Prompting People</a></li>
                <li><a href="ex13.html">Ex13: Parameters, Unpacking, Variables</a></li>
                <li><a href="ex14.html">Ex14: Prompting And Passing</a></li>
                <li><a href="ex15.html">Ex15: Reading Files</a></li>
                <li><a href="ex16.html">Ex16: Reading And Writing Files</a></li>
                <li><a href="ex17.html">Ex17: More Files</a></li>
                <li><a href="ex18.html">Ex18: Names, Variables, Code, Functions</a></li>
                <li><a href="ex19.html">Ex19: Functions And Variables</a></li>
                <li><a href="ex20.html">Ex20: Functions And Files</a></li>
                <li><a href="ex21.html">Ex21: Functions Can Return Something</a></li>
                <li><a href="ex22.html">Ex22: What Do You Know So Far?</a></li>
                <li><a href="ex23.html">Ex23: Read Some Code</a></li>
                <li><a href="ex24.html">Ex24: More Practice</a></li>
                <li><a href="ex25.html">Ex25: Even More Practice</a></li>
                <li><a href="ex26.html">Ex26: Congratulations, Take A Test!</a></li>
                <li><a href="ex27.html">Ex27: Memorizing Logic</a></li>
                <li><a href="ex28.html">Ex28: Boolean Practice</a></li>
                <li><a href="ex29.html">Ex29: What If</a></li>
                <li><a href="ex30.html">Ex30: Else And If</a></li>
                <li><a href="ex31.html">Ex31: Making Decisions</a></li>
                <li><a href="ex32.html">Ex32: Loops And Lists</a></li>
                <li><a href="ex33.html">Ex33: While Loops</a></li>
                <li><a href="ex34.html">Ex34: Accessing Elements Of Lists</a></li>
                <li><a href="ex35.html">Ex35: Branches and Functions</a></li>
                <li><a href="ex36.html">Ex36: Designing and Debugging</a></li>
                <li><a href="ex37.html">Ex37: Symbol Review</a></li>
                <li><a href="ex38.html">Ex38: Doing Things To Lists</a></li>
                <li><a href="ex39.html">Ex39: Dictionaries, Oh Lovely Dictionaries</a></li>
                <li><a href="ex40.html">Ex40: Modules, Classes, And Objects</a></li>
                <li><a href="ex41.html">Ex41: Learning To Speak Object Oriented</a></li>
                <li><a href="ex42.html">Ex42: Is-A, Has-A, Objects, and Classes</a></li>
                <li><a href="ex43.html">Ex43: Gothons From Planet Percal #25</a></li>
                <li><a href="ex44.html">Ex44: Inheritance Vs. Composition</a></li>
                <li><a href="ex45.html">Ex45: You Make A Game</a></li>
                <li><a href="ex46.html">Ex46: A Project Skeleton</a></li>
                <li><a href="ex47.html">Ex47: Automated Testing</a></li>
                <li><a href="ex48.html">Ex48: Advanced User Input</a></li>
                <li><a href="ex49.html">Ex49: Making Sentences</a></li>
                <li><a href="ex50.html">Ex50: Your First Website</a></li>
                <li><a href="ex51.html">Ex51: Getting Input From A Browser</a></li>
                <li><a href="ex52.html">Ex52: The Start Of Your Web Game</a></li>
                <li><a href="advice.html">Advice From An Old Programmer</a></li>
                <li><a href="next.html">Next Steps</a></li>
                <li><a href="appendixa.html">Appendix A: Command Line Crash Course</a></li>
            </ol>
            <ul class="site-links">
                <h3>Learn the Hard Way</h3>
                <li><a href="ex41.html#" class="waves-effect"><i class="icon-information"></i> About LPTHW</a></li>
                <li><a href="ex41.html#" class="waves-effect"><i class="icon-question-mark"></i> Help &amp; Support</a></li>
                <li><a href="ex41.html#" class="waves-effect"><i class="socicon-twitter"></i> Follow us on Twitter</a></li>
            </ul>
        </nav>
        <div class="colophon text-center">
            <div class="intro">
                <p class="bare-bottom">
                The type for this book is set in 18px / 1.5
                <a href="https://www.google.com/fonts/specimen/Source+Serif+Pro">Adobe Serif</a>,
                <a href="https://www.google.com/fonts/specimen/Source+Sans+Pro">Sans</a>, and
                <a href="https://www.google.com/fonts/specimen/Source+Code+Pro">Code</a>.
                </p>
            </div>
            <div class="printers-mark">
                <div class="inscription">Docendo <i class="icon-repeat"></i> Discimus</div>
            </div>
        </div>
    </aside>

    <div class="overlay"></div>

    <main class="main python" role="main">
    <div class="main-container row center-xs">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">

            <div class="content">
                <!--- RST STARTS -->
                <h1 class="title">Exercise 41: Learning To Speak Object Oriented</h1>
                <p>In this exercise I'm going to teach you how to speak &quot;object oriented.&quot;  What I'll do is give you a small set of words with definitions you need to know.  Then I'll give you a set of sentences with holes in them that you'll have to understand.  Finally, I'm going to give you a large set of exercises that you have to complete to make these sentences solid in your vocabulary.</p>
<div class="section" id="word-drills">
<h1>Word Drills</h1>
<dl class="docutils">
<dt>class</dt>
<dd>Tell Python to make a new type of thing.</dd>
<dt>object</dt>
<dd>Two meanings: the most basic type of thing, and any instance of some thing.</dd>
<dt>instance</dt>
<dd>What you get when you tell Python to create a class.</dd>
<dt>def</dt>
<dd>How you define a function inside a class.</dd>
<dt>self</dt>
<dd>Inside the functions in a class, self is a variable for the instance/object being accessed.</dd>
<dt>inheritance</dt>
<dd>The concept that one class can inherit traits from another class, much like you and your parents.</dd>
<dt>composition</dt>
<dd>The concept that a class can be composed of other classes as parts, much like how a car has wheels.</dd>
<dt>attribute</dt>
<dd>A property classes have that are from composition and are usually variables.</dd>
<dt>is-a</dt>
<dd>A phrase to say that something inherits from another, as in a &quot;salmon&quot; is-a &quot;fish.&quot;</dd>
<dt>has-a</dt>
<dd>A phrase to say that something is composed of other things or has a trait, as in &quot;a salmon has-a mouth.&quot;</dd>
</dl>
<p>Take some time to make flash cards for these terms and memorize them.  As usual this won't make too much sense until after you are finished with this exercise, but you need to know the base words first.</p>
</div>
<div class="section" id="phrase-drills">
<h1>Phrase Drills</h1>
<p>Next I have a list of Python code snippets on the left, and the English sentences for them:</p>
<dl class="docutils">
<dt>class X(Y)</dt>
<dd>&quot;Make a class named X that is-a Y.&quot;</dd>
<dt>class X(object): def __init__(self, J)</dt>
<dd>&quot;class X has-a __init__ that takes self and J parameters.&quot;</dd>
<dt>class X(object): def M(self, J)</dt>
<dd>&quot;class X has-a function named M that takes self and J parameters.&quot;</dd>
<dt>foo = X()</dt>
<dd>&quot;Set foo to an instance of class X.&quot;</dd>
<dt>foo.M(J)</dt>
<dd>&quot;From foo get the M function, and call it with parameters self, J.&quot;</dd>
<dt>foo.K = Q</dt>
<dd>&quot;From foo get the K attribute and set it to Q.&quot;</dd>
</dl>
<p>In each of these where you see X, Y, M, J, K, Q, and foo you can treat those like blank spots.  For example, I can also write these sentences as follows:</p>
<ol class="arabic simple">
<li>&quot;Make a class named ??? that is-a Y.&quot;</li>
<li>&quot;class ??? has-a __init__ that takes self and ??? parameters.&quot;</li>
<li>&quot;class ??? has-a function named ??? that takes self and  ??? parameters.&quot;</li>
<li>&quot;Set foo to an instance of class ???.&quot;</li>
<li>&quot;From foo get the ??? function, and call it with self=??? and  parameters ???.&quot;</li>
<li>&quot;From foo get the ??? attribute and set it to ???.&quot;</li>
</ol>
<p>Again, write these on some flash cards and drill them.  Put the Python code snippet on the front and the sentence on the back.  You <em>have</em> to be able to say the sentence exactly the same every time whenever you see that form.  Not sort of the same, but exactly the same.</p>
</div>
<div class="section" id="combined-drills">
<h1>Combined Drills</h1>
<p>The final preparation for you is to combine the words drills with the phrase drills.  What I want you to do for this drill is this:</p>
<ol class="arabic simple">
<li>Take a phrase card and drill it.</li>
<li>Flip it over and read the sentence, and for each word in the sentence that is in your words drills, get that card.</li>
<li>Drill those words for that sentence.</li>
<li>Keep going until you are bored, then take a break and do it again.</li>
</ol>
</div>
<div class="section" id="a-reading-test">
<h1>A Reading Test</h1>
<p>I now have a little Python hack script that will drill you on these words you know in an infinite manner.  This is a simple script you should be able to figure out, and the only thing it does is use a library called <tt class="docutils literal">urllib</tt> to download a list of words I have.  Here's the script, which you should enter into <tt class="docutils literal">oop_test.py</tt> to work with it:</p>
<table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82</pre></div></td><td class="code"><div class="highlight"><pre><span></span><a name="python--ex41.py-idio.html-1"></a><span class="kn">import</span> <span class="nn">random</span>
<a name="python--ex41.py-idio.html-2"></a><span class="kn">from</span> <span class="nn">urllib</span> <span class="kn">import</span> <span class="n">urlopen</span>
<a name="python--ex41.py-idio.html-3"></a><span class="kn">import</span> <span class="nn">sys</span>
<a name="python--ex41.py-idio.html-4"></a>
<a name="python--ex41.py-idio.html-5"></a><span class="n">WORD_URL</span> <span class="o">=</span> <span class="s2">&quot;http://learncodethehardway.org/words.txt&quot;</span>
<a name="python--ex41.py-idio.html-6"></a><span class="n">WORDS</span> <span class="o">=</span> <span class="p">[]</span>
<a name="python--ex41.py-idio.html-7"></a>
<a name="python--ex41.py-idio.html-8"></a><span class="n">PHRASES</span> <span class="o">=</span> <span class="p">{</span>
<a name="python--ex41.py-idio.html-9"></a>    <span class="s2">&quot;class </span><span class="si">%%</span><span class="s2">%(</span><span class="si">%%</span><span class="s2">%):&quot;</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-10"></a>      <span class="s2">&quot;Make a class named </span><span class="si">%%</span><span class="s2">% that is-a </span><span class="si">%%</span><span class="s2">%.&quot;</span><span class="p">,</span>
<a name="python--ex41.py-idio.html-11"></a>    <span class="s2">&quot;class </span><span class="si">%%</span><span class="s2">%(object):</span><span class="se">\n\t</span><span class="s2">def __init__(self, ***)&quot;</span> <span class="p">:</span>
<a name="python--ex41.py-idio.html-12"></a>      <span class="s2">&quot;class </span><span class="si">%%</span><span class="s2">% has-a __init__ that takes self and *** parameters.&quot;</span><span class="p">,</span>
<a name="python--ex41.py-idio.html-13"></a>    <span class="s2">&quot;class </span><span class="si">%%</span><span class="s2">%(object):</span><span class="se">\n\t</span><span class="s2">def ***(self, @@@)&quot;</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-14"></a>      <span class="s2">&quot;class </span><span class="si">%%</span><span class="s2">% has-a function named *** that takes self and @@@ parameters.&quot;</span><span class="p">,</span>
<a name="python--ex41.py-idio.html-15"></a>    <span class="s2">&quot;*** = </span><span class="si">%%</span><span class="s2">%()&quot;</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-16"></a>      <span class="s2">&quot;Set *** to an instance of class </span><span class="si">%%</span><span class="s2">%.&quot;</span><span class="p">,</span>
<a name="python--ex41.py-idio.html-17"></a>    <span class="s2">&quot;***.***(@@@)&quot;</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-18"></a>      <span class="s2">&quot;From *** get the *** function, and call it with parameters self, @@@.&quot;</span><span class="p">,</span>
<a name="python--ex41.py-idio.html-19"></a>    <span class="s2">&quot;***.*** = &#39;***&#39;&quot;</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-20"></a>      <span class="s2">&quot;From *** get the *** attribute and set it to &#39;***&#39;.&quot;</span>
<a name="python--ex41.py-idio.html-21"></a><span class="p">}</span>
<a name="python--ex41.py-idio.html-22"></a>
<a name="python--ex41.py-idio.html-23"></a><span class="c1"># do they want to drill phrases first</span>
<a name="python--ex41.py-idio.html-24"></a><span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">)</span> <span class="o">==</span> <span class="mi">2</span> <span class="ow">and</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="o">==</span> <span class="s2">&quot;english&quot;</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-25"></a>    <span class="n">PHRASE_FIRST</span> <span class="o">=</span> <span class="bp">True</span>
<a name="python--ex41.py-idio.html-26"></a><span class="k">else</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-27"></a>    <span class="n">PHRASE_FIRST</span> <span class="o">=</span> <span class="bp">False</span>
<a name="python--ex41.py-idio.html-28"></a>
<a name="python--ex41.py-idio.html-29"></a><span class="c1"># load up the words from the website</span>
<a name="python--ex41.py-idio.html-30"></a><span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">urlopen</span><span class="p">(</span><span class="n">WORD_URL</span><span class="p">)</span><span class="o">.</span><span class="n">readlines</span><span class="p">():</span>
<a name="python--ex41.py-idio.html-31"></a>    <span class="n">WORDS</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">word</span><span class="o">.</span><span class="n">strip</span><span class="p">())</span>
<a name="python--ex41.py-idio.html-32"></a>
<a name="python--ex41.py-idio.html-33"></a>
<a name="python--ex41.py-idio.html-34"></a><span class="k">def</span> <span class="nf">convert</span><span class="p">(</span><span class="n">snippet</span><span class="p">,</span> <span class="n">phrase</span><span class="p">):</span>
<a name="python--ex41.py-idio.html-35"></a>    <span class="n">class_names</span> <span class="o">=</span> <span class="p">[</span><span class="n">w</span><span class="o">.</span><span class="n">capitalize</span><span class="p">()</span> <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span>
<a name="python--ex41.py-idio.html-36"></a>                   <span class="n">random</span><span class="o">.</span><span class="n">sample</span><span class="p">(</span><span class="n">WORDS</span><span class="p">,</span> <span class="n">snippet</span><span class="o">.</span><span class="n">count</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">%%</span><span class="s2">%&quot;</span><span class="p">))]</span>
<a name="python--ex41.py-idio.html-37"></a>    <span class="n">other_names</span> <span class="o">=</span> <span class="n">random</span><span class="o">.</span><span class="n">sample</span><span class="p">(</span><span class="n">WORDS</span><span class="p">,</span> <span class="n">snippet</span><span class="o">.</span><span class="n">count</span><span class="p">(</span><span class="s2">&quot;***&quot;</span><span class="p">))</span>
<a name="python--ex41.py-idio.html-38"></a>    <span class="n">results</span> <span class="o">=</span> <span class="p">[]</span>
<a name="python--ex41.py-idio.html-39"></a>    <span class="n">param_names</span> <span class="o">=</span> <span class="p">[]</span>
<a name="python--ex41.py-idio.html-40"></a>
<a name="python--ex41.py-idio.html-41"></a>    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">snippet</span><span class="o">.</span><span class="n">count</span><span class="p">(</span><span class="s2">&quot;@@@&quot;</span><span class="p">)):</span>
<a name="python--ex41.py-idio.html-42"></a>        <span class="n">param_count</span> <span class="o">=</span> <span class="n">random</span><span class="o">.</span><span class="n">randint</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">3</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-43"></a>        <span class="n">param_names</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s1">&#39;, &#39;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">random</span><span class="o">.</span><span class="n">sample</span><span class="p">(</span><span class="n">WORDS</span><span class="p">,</span> <span class="n">param_count</span><span class="p">)))</span>
<a name="python--ex41.py-idio.html-44"></a>
<a name="python--ex41.py-idio.html-45"></a>    <span class="k">for</span> <span class="n">sentence</span> <span class="ow">in</span> <span class="n">snippet</span><span class="p">,</span> <span class="n">phrase</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-46"></a>        <span class="n">result</span> <span class="o">=</span> <span class="n">sentence</span><span class="p">[:]</span>
<a name="python--ex41.py-idio.html-47"></a>
<a name="python--ex41.py-idio.html-48"></a>        <span class="c1"># fake class names</span>
<a name="python--ex41.py-idio.html-49"></a>        <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">class_names</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-50"></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">%%</span><span class="s2">%&quot;</span><span class="p">,</span> <span class="n">word</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-51"></a>
<a name="python--ex41.py-idio.html-52"></a>        <span class="c1"># fake other names</span>
<a name="python--ex41.py-idio.html-53"></a>        <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">other_names</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-54"></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;***&quot;</span><span class="p">,</span> <span class="n">word</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-55"></a>
<a name="python--ex41.py-idio.html-56"></a>        <span class="c1"># fake parameter lists</span>
<a name="python--ex41.py-idio.html-57"></a>        <span class="k">for</span> <span class="n">word</span> <span class="ow">in</span> <span class="n">param_names</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-58"></a>            <span class="n">result</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;@@@&quot;</span><span class="p">,</span> <span class="n">word</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-59"></a>
<a name="python--ex41.py-idio.html-60"></a>        <span class="n">results</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">result</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-61"></a>
<a name="python--ex41.py-idio.html-62"></a>    <span class="k">return</span> <span class="n">results</span>
<a name="python--ex41.py-idio.html-63"></a>
<a name="python--ex41.py-idio.html-64"></a>
<a name="python--ex41.py-idio.html-65"></a><span class="c1"># keep going until they hit CTRL-D</span>
<a name="python--ex41.py-idio.html-66"></a><span class="k">try</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-67"></a>    <span class="k">while</span> <span class="bp">True</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-68"></a>        <span class="n">snippets</span> <span class="o">=</span> <span class="n">PHRASES</span><span class="o">.</span><span class="n">keys</span><span class="p">()</span>
<a name="python--ex41.py-idio.html-69"></a>        <span class="n">random</span><span class="o">.</span><span class="n">shuffle</span><span class="p">(</span><span class="n">snippets</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-70"></a>
<a name="python--ex41.py-idio.html-71"></a>        <span class="k">for</span> <span class="n">snippet</span> <span class="ow">in</span> <span class="n">snippets</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-72"></a>            <span class="n">phrase</span> <span class="o">=</span> <span class="n">PHRASES</span><span class="p">[</span><span class="n">snippet</span><span class="p">]</span>
<a name="python--ex41.py-idio.html-73"></a>            <span class="n">question</span><span class="p">,</span> <span class="n">answer</span> <span class="o">=</span> <span class="n">convert</span><span class="p">(</span><span class="n">snippet</span><span class="p">,</span> <span class="n">phrase</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-74"></a>            <span class="k">if</span> <span class="n">PHRASE_FIRST</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-75"></a>                <span class="n">question</span><span class="p">,</span> <span class="n">answer</span> <span class="o">=</span> <span class="n">answer</span><span class="p">,</span> <span class="n">question</span>
<a name="python--ex41.py-idio.html-76"></a>
<a name="python--ex41.py-idio.html-77"></a>            <span class="k">print</span> <span class="n">question</span>
<a name="python--ex41.py-idio.html-78"></a>
<a name="python--ex41.py-idio.html-79"></a>            <span class="nb">raw_input</span><span class="p">(</span><span class="s2">&quot;&gt; &quot;</span><span class="p">)</span>
<a name="python--ex41.py-idio.html-80"></a>            <span class="k">print</span> <span class="s2">&quot;ANSWER:  </span><span class="si">%s</span><span class="se">\n\n</span><span class="s2">&quot;</span> <span class="o">%</span> <span class="n">answer</span>
<a name="python--ex41.py-idio.html-81"></a><span class="k">except</span> <span class="ne">EOFError</span><span class="p">:</span>
<a name="python--ex41.py-idio.html-82"></a>    <span class="k">print</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">Bye&quot;</span>
</pre></div>
</td></tr></table><p>Run this script and try to translate the &quot;object-oriented phrases&quot; into English translations.  You should see that the <tt class="docutils literal">PHRASES</tt> dict has both forms and you just have to enter the correct one.</p>
</div>
<div class="section" id="practice-english-to-code">
<h1>Practice English to Code</h1>
<p>Next you should run the script with the &quot;english&quot; option so that you drill the inverse operation:</p>
<pre class="code sh literal-block">
$ python oop_test.py english
</pre>
<p>Remember that these phrases are using nonsense words.  Part of learning to read code well is to stop placing so much meaning on the names used for variables and classes.  Too often people will read a word like &quot;Cork&quot; and suddenly get derailed because that word will confuse them about the meaning.  In the above example, &quot;Cork&quot; is just an arbitrary name chosen for a class.  Don't place any other meaning on it, and instead treat it like the patterns I've given you.</p>
</div>
<div class="section" id="reading-more-code">
<h1>Reading More Code</h1>
<p>You are now to go on a new quest to read even more code, to read the phrases you just learned in the code you read.  You will look for all the files with classes, and then do the following:</p>
<ol class="arabic simple">
<li>For each class give its name and what other classes it inherits from.</li>
<li>Under that, list every function it has and the parameters they take.</li>
<li>List all of the attributes it uses on its self.</li>
<li>For each attribute, give the class this attribute is.</li>
</ol>
<p>The goal is to go through real code and start learning to &quot;pattern match&quot; the phrases you just learned against how they're used.  If you drill this enough you should start to see these patterns shout at you in the code whereas before they just seemed like vague blank spots you didn't know.</p>
</div>
<div class="section" id="common-student-questions">
<h1>Common Student Questions</h1>
<dl class="docutils">
<dt>What does <tt class="docutils literal">result = <span class="pre">sentence[:]</span></tt> do?</dt>
<dd>That's a Python way of copying a list.  You're using the list slice syntax <tt class="docutils literal">[:]</tt> to effectively make a slice from the very first element to the very last one.</dd>
<dt>This script is hard to get running!</dt>
<dd>By this point you should be able to type this in and get it working.  It does have a few little tricks here and there but there's nothing complex about it.  Just do all the things you've learned so far to debug scripts.  Type each line in, confirm that it's <em>exactly</em> like mine, and research anything you don't know online.</dd>
<dt>It's still too hard!</dt>
<dd>You can do this. Take it very slow, character by character if you have to, but type it in exactly and figure out what it does.</dd>
</dl>
</div>
                <!-- RST ENDS -->
            </div>
        </div>

        <div class="row center-xs" id="buy">
            <div class="text-center col-xs-10 col-sm-5 col-md-4">
                <h2 class="section-title__small">Buy The Python 2 Course</h2>
                <p>
                When you buy directly from the author, Zed A. Shaw, you'll get a professional
                quality PDF and  hours of HD Video, all DRM-free and yours to download.
                </p>

                <p class="price-block">
                <span class="currency"><span class="prefix">$</span>29.<span class="suffix">99</span></span>
                </p>

                <a href="https://shop.learncodethehardway.org/access/buy/2/" class="btn btn-primary btn-full">Buy The Python 2 Course</a>
                <a href="https://shop.learncodethehardway.org/access/buy/9/" class="btn btn-primary btn-full">Pre-Order The Python 3 Course Instead</a>

                <p class="text-left btn-subtext">
                <small>Or, you can <a href="https://learnpythonthehardway.org/book/book_2.html">read Learn Python the Hard Way for free</a> right here, video lectures not included.</small>
                </p>

            </div>
            <div class="text-center col-xs-10 col-sm-5 col-md-4 col-sm-offset-1">

                <h2 class="section-title__small">Other Buying Options</h2>
                <a href="http://bit.ly/amznlpthw" class="btn btn-secondary btn-full">Buy on Amazon</a>
                <a href="http://bit.ly/informitlpthw" class="btn btn-secondary btn-full">Buy a hard copy from the Publisher</a>
                <a href="http://bit.ly/bnlpthw" class="btn btn-secondary btn-full">Buy a hard copy from Barnes &amp; Noble</a>

            </div>
        </div>
    </div>

    <div class="row center-xs" id="video_holder" style="display: none">
        <div class="col-xs-11 col-sm-10 col-md-9 col-lg-8">
            <div data-paydiv_product="2" id='paydiv'>
                No content available for this exercise.  You can view all available downloads at <a href="https://shop.learncodethehardway.org/customers/">your customer account page</a>.
            </div>
        </div>
    </div>
    </main>

</div>

<div class="row dark bottom-nav">
    <div class="col-xs text-left">
        <a href="ex41.html" class="prev" id='prev_link'><i class="icon-arrow-67"></i> <i class="icon icon-arrow-left"></i> Previous <span class="hide-xs show-sm-inline">Lesson</span></a>
    </div>
    <div class="col-xs text-right"><a href="ex41.html" class="next" id='next_link'>Next <span class="hide-xs show-sm-inline">Lesson</span> <i class="icon icon-arrow-right"></i></a>
    </div>
</div>
  </div>

<footer class="footer">
<div class="row center-xs">

    <div class="col-xs-11 col-sm-6 col-md-5 col-lg-5">
        <ul class="nav nav-inline">
            <li><h4><a href="https://learnpythonthehardway.org/learnpythonthehardway_default_2.html">Home</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/about/">About</a></h4></li>
            <li><h4><a href="https://learncodethehardway.org/contact/">Contact</a></h4></li>
        </ul>
        <div class="copyright text-left">
            <small class="text-muted">&copy; 2016 Zed A. Shaw. All rights reserved.</small>
        </div>
    </div>
    <div class="col-xs-11 col-sm-4 col-md-4 col-lg-3">
        <div class="social-media">
            <div class="classy-container">
                <a href="https://twitter.com/lzsthw" class="socicon-twitter"></a>
            </div>
        </div>
    </div>
</div>

</footer>
<script src="../js/scripts.min.js"></script>

<script src="javascripts/jquery.js"></script>
<script src="index.js"></script>
<script src="https://shop.learncodethehardway.org/static/jzed.js"></script>
<script src="https://shop.learncodethehardway.org/static/js/videojs/video.js"></script>
<link rel="stylesheet" href="https://shop.learncodethehardway.org/static/js/videojs/video-js.css">
<script src="https://shop.learncodethehardway.org/static/api/v1/paydiv.js"></script>
<script src="javascripts/app.js"></script>
<script src="javascripts/littools.js"></script>
<!-- Start of helpthw Zendesk Widget script -->
<script>/*<![CDATA[*/window.zEmbed||function(e,t){var n,o,d,i,s,a=[],r=document.createElement("iframe");window.zEmbed=function(){a.push(arguments)},window.zE=window.zE||window.zEmbed,r.src="javascript:false",r.title="",r.role="presentation",(r.frameElement||r).style.cssText="display: none",d=document.getElementsByTagName("script"),d=d[d.length-1],d.parentNode.insertBefore(r,d),i=r.contentWindow,s=i.document;try{o=s}catch(e){n=document.domain,r.src='javascript:var d=document.open();d.domain="'+n+'";void(0);',o=s}o.open()._l=function(){var o=this.createElement("script");n&&(this.domain=n),o.id="js-iframe-async",o.src=e,this.t=+new Date,this.zendeskHost=t,this.zEQueue=a,this.body.appendChild(o)},o.write('<body onload="document._l();">'),o.close()}("https://assets.zendesk.com/embeddable_framework/main.js","helpthw.zendesk.com");
/*]]>*/</script>
<!-- End of helpthw Zendesk Widget script -->
<script>
(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
 (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
 m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
 })(window,document,'script','https://www.google-analytics.com/analytics.js','ga');

ga('create', 'UA-24168052-1', 'auto');
ga('send', 'pageview');

</script>

</body>
</html>
